/*
Don't forget to edit models.dat if you want SkyFox to have a 3D model!
You can just copy and paste the following line into the file if you want to use the default model
SKYFOX PLAY/TAILS.md3 3.0 0.0

Reused stuff will be at the bottom (or, in the case of ring attraction, in a separate Lua file).

Files I stole from:
	- Kirb's airwalk remover v3
	- Kirb's Extra Spicy Momentum v1
	- Mystic Akito's All Characters super! v4
	- Krab's Uncurl v4
	- clairebun's The Momentum Mod v9
	- EeveeEuphoria's Cancelable Super Form v2.1
	- SlainLBS's Character Specific Jingles v2.2
	- Golden's Classic Ring Attraction v1(VL_ringattraction-v1.lua - unused, but still here if you feel like messing with it!)
*/

local hangtic=0--Tic counter; tracks how long you've been hanging on to a rope or bar
local flightcharge=0--Tic counter; recharges your energy when you've cancelled flying
local flightpower=0--Saves the last value of pw_tailsfly, since it resets to 0 when you stop flying
local flightcancel=0--Binary value, checks if you've flightcancelled or not. 0 is false, 1 is true
local refly=0--flightcharge+flightpower. Set as a new pw_tailsfly when you refly
local flighthold=0--Tic counter; tracks how long you've pressed JUMP while flying. Used to get that first big boost. Controls z acceleration
local acceltic=0--Another tic counter, controls whether or not you get + or -z acceleration. Only used for the first boost.
local spintic=0--Take a guess :P This one's for how long you hold the SPIN key
local cstmtic=0--Another one! This is for CUSTOM1
local momzprevtic=0--Stores your mo.momz of the previous tic, which is then compared to current mo.momz
local nosedive=0--For the NotAGroundPound
local waterrun=0--Checks if you're able to run on water or not
local ptb=0--Checks if you've been carried by a Pterabyte
local soundcheck=0--Used for the audio that plays when you enter/exit my knockoff version of dashmode

addHook("PlayerThink",function(player)
if player.mo.skin=="skyfox"--if not playing custom fox boi then nothing changes
	if player.flighthold==nil--random bug hotfix
		player.flighthold=0
		end
	if not(player.powers[pw_carry]or(player.mo.state == S_PLAY_RIDE))--if not being carried
		player.height=32*FRACUNIT--make fox boi smol
		player.hangtic=0
	else
		player.hangtic=$+1--otherwise start counting
		player.height=48*FRACUNIT--and make fox boi normal for ropes/hang bars
		if player.hangtic==1
			player.mo.z=$-16*FRACUNIT
			end
		end

	--Fixes your damage/jump state in air
	if player.powers[pw_carry]==11
		player.ptb=1
		end
	if(P_IsObjectOnGround(player.mo))
		player.ptb=0
		end
	if not(player.pflags&PF_JUMPED)
		if not(P_IsObjectOnGround(player.mo)or(player.powers[pw_carry]))--if you're in the air and didn't jump, and aren't being carried by anything
			if (player.mo.state==S_PLAY_FALL or player.mo.state==S_PLAY_SPRING or player.mo.state==S_PLAY_PAIN)--if airwalking or springing or hurt
			and player.powers[pw_carry]~=11
				player.pflags=$|PF_NOJUMPDAMAGE--don't hurt stuff
				player.pflags=$|PF_JUMPED--you can use your ability (doesn't work for PAIN w/o aircurling first)
				player.pflags=$&~PF_THOKKED--just in case
				end
			if player.mo.state==S_PLAY_ROLL--if rolling and you press jump
				if player.cmd.buttons&BT_JUMP--Can't figure out how to make it so you only have to jump once, otherwise it just won't let you waterbounce. Oh well.
					player.pflags=$&~PF_SPINNING--no more spinny
					player.pflags=$|PF_NOJUMPDAMAGE--see above
					player.pflags=$|PF_JUMPED--see above
					player.pflags=$&~PF_THOKKED--see above
					player.mo.state=S_PLAY_FALL--make it obvious you're not gonna waterbounce again
					end
				end
			end
		end
	if player.ptb==1 and player.mo.state==S_PLAY_ROLL--Pterabytes are weird, they don't let you use your air ability after you escape from them
		player.pflags=$|PF_JUMPED--so let's fix that
		player.pflags=$&~PF_THOKKED
		end
		

	--Homemade flight cancel script
	if(P_IsObjectOnGround(player.mo))
		player.flightcancel=0
		player.nosedive=0
		end
	if player.mo.state==S_PLAY_FLY or player.mo.state==S_PLAY_SWIM or player.mo.state==S_PLAY_FLY_TIRED
		player.flightcharge=0
		if player.cmd.buttons&BT_CUSTOM1--if you press the flight cancel button
			player.pflags=$&~PF_NOJUMPDAMAGE--set the player as if they jumped
			player.pflags=$|PF_JUMPED
			player.pflags=$&~PF_THOKKED
			player.flightcancel=1--also set this to one 
			player.mo.state=S_PLAY_ROLL
			S_StartSound(player.mo,sfx_zoom)
			end
		end

	--NotAGrandSlam
	if player.cmd.buttons&BT_CUSTOM1
		player.cstmtic=$+1
		end
	if not(player.cmd.buttons&BT_CUSTOM1)
		player.cstmtic=0
		end
	if(player.mo.state==S_PLAY_FLY and player.flightcancel==2)or(player.mo.state==S_PLAY_RUN and player.cmd.buttons&BT_CUSTOM1)--Ensure you don't immediately nosedive when flightcancelling or falling into water
		player.flightcancel=1
		end
	if player.flightcancel==1 and not(player.cmd.buttons&BT_CUSTOM1)--Let go of the key and now you can!
		player.flightcancel=2
		end
	if player.nosedive==0 and player.cmd.buttons&BT_CUSTOM1 and player.flightcancel~=1 and player.waterrun==0 and player.cstmtic==2 and not((P_IsObjectOnGround(player.mo))or(player.powers[pw_carry]~=0)or(player.mo.state==S_PLAY_DEAD or player.mo.state==S_PLAY_DRWN))--Meet the right conditions
		player.pflags=$&~PF_NOJUMPDAMAGE--rinse and repeat
		player.pflags=$|PF_JUMPED
		player.pflags=$&~PF_THOKKED
		player.powers[pw_strong]=STR_BOUNCE|STR_CEILING
		player.mo.state=S_PLAY_ROLL
		if not(player.mo.eflags&MFE_VERTICALFLIP)
			player.mo.momz=-50*FRACUNIT--Speed!
		elseif player.mo.eflags&MFE_VERTICALFLIP
			player.mo.momz=50*FRACUNIT
			end
		player.nosedive=1
		S_StartSound(player.mo,sfx_cdfm62)--The only vanilla sound I liked that wasn't sfx_zoom
		end
	if player.nosedive==1
		if not(player.mo.eflags&MFE_VERTICALFLIP)
			if player.mo.momz<-40*FRACUNIT and player.mo.state==S_PLAY_ROLL
				P_SpawnThokMobj(player)--Give it a cool visual
				end
			if player.mo.momz>16*FRACUNIT and not(player.mo.state==S_PLAY_SPRING)--If you bounce off a monitor or enemy
				player.mo.momz=16*FRACUNIT--Don't bounce super high (you can change this, just make sure to change both lines)
				end
			end
		if player.mo.eflags&MFE_VERTICALFLIP
			if player.mo.momz>40*FRACUNIT and player.mo.state==S_PLAY_ROLL
				P_SpawnThokMobj(player)
				end
			if player.mo.momz<-16*FRACUNIT and not(player.mo.state==S_PLAY_SPRING)
				player.mo.momz=-16*FRACUNIT
				end
			end
		end
	if player.powers[pw_carry]
		player.nosedive=0
		end

	--Homemade airwalk script, as a backup to Kirb's (found further down)
	--This one actually compares the change in your z momentum to see if you're being affected by gravity or not (-1/2*FRACUNIT per tic)
	--I literally only made this because running against the wall in GFZ1's tunnel wouldn't start an airwalk :P
	if player.mo.state==S_PLAY_WALK or player.mo.state==S_PLAY_RUN or player.mo.state==S_PLAY_STND or player.mo.state==S_PLAY_WAIT or player.mo.state==S_PLAY_SKID or player.mo.state==S_PLAY_DASH
		if player.momzprevtic~=0
			if player.mo.momz==player.momzprevtic-32768
				player.mo.state=S_PLAY_FALL
				end
			end
		if player.momzprevtic==0--Gravity is doubled for a single tic when zmom==0
			if player.mo.momz==player.momzprevtic-65536
				player.mo.state=S_PLAY_FALL
				end
			end
		end
	player.momzprevtic=player.mo.momz

	--Flight extender
	if player.powers[pw_tailsfly]==280--equivalent to 8*TICRATE
		player.powers[pw_tailsfly]=352--10*TICRATE+2. you'll see what the extra 2 is for in a bit
		end
	if player.powers[pw_tailsfly]<352
	and player.powers[pw_tailsfly]~=0--if you didn't just start flying & aren't tired
		player.flightpower=player.powers[pw_tailsfly]--store the tailsfly value (it's set to 0 when not flying)
		end
	if player.mo.state==S_PLAY_ROLL--if cancelled flight (probably redundant but whatever)
		if player.flightcancel>0--if it's not 0 then do some math to recharge
			player.flightcharge=$+1
			end
		end
	player.refly=player.flightpower+(player.flightcharge/2)--recharge at half rate (change the 2 to make it come back faster or slower)
	if player.refly>352--hey you can't go that high
		player.refly=352
		end
	if player.flightcancel>0--if you start flying again
		if player.powers[pw_tailsfly]==352--it's gonna wanna be full
			player.powers[pw_tailsfly]=player.refly--no
			if player.powers[pw_super]>0
				player.fly1=20
				end
			end
		end
	if player.powers[pw_tailsfly]==281
		player.powers[pw_tailsfly]=279 --skip 280 to avoid an infinite loop (what the extra 2 is for)
		end
	if player.cmd.buttons&BT_JUMP
		if player.mo.state==S_PLAY_FLY or player.mo.state==S_PLAY_SWIM
			player.flighthold=$+1--tic counter
			end
		end
	if not(player.cmd.buttons&BT_SPIN)
		player.spintic=0
		end
	
	--massive script, go ahead and collapse this if you don't wanna have to go through four duplicates of mostly the same script
	--(Most efficient coder:)
	if player.mo.state==S_PLAY_FLY or player.mo.state==S_PLAY_SWIM
		if not(player.mo.eflags&MFE_VERTICALFLIP)--if rightside up (yeah i have to change it if gravity's reversed)
			if player.mo.state==S_PLAY_FLY--two different accel rates for air & water
				if player.flighthold==1
					player.fly1=20--if started flying, force altitude gain (seriously i DON'T WANNA HAVE TO DOUBLE TAP)
					player.acceltic=1--another surprise tool that will help us later
					player.flighthold=2--avoid infinite vertical accel
					end
				if((player.flighthold<21)and(player.flighthold>0))--if within boost window
					if player.cmd.buttons&BT_JUMP
						player.acceltic=$+1--equal to flighthold
						player.mo.momz=$+(6810*player.flighthold)--increase your momz. change 6810 to affect how fast you go
						end
					if not(player.cmd.buttons&BT_JUMP)--when you release jump
						player.flighthold=21--set this outside the boost window to avoid inf flight boost normally
						end
					end
				if player.flighthold>20 or player.fly1==0--after  first tap
					if player.cmd.buttons&BT_JUMP		--Technically this line should be removed, so you level out when you let go of the jump key, but leaving
						if player.mo.momz<(6*FRACUNIT)	--it in lets you get insane heights so I'll let it go lol. Have fun reaching the highest of heavens!
							player.acceltic=0--if you're already within normal climb rate for Tails, do nothing
							end
						if player.acceltic>0--set this to negative because yes
							player.acceltic=-player.acceltic
							end
						if player.acceltic<0--keep increasing
							player.acceltic=$+1
							player.mo.momz=$-(1250*player.flighthold)--while -x, decrease your climb rate
							end
						if player.acceltic==0--do nothing
							player.acceltic=0--make sure nothing happens
							end
						end
					if not(player.cmd.buttons&BT_JUMP)
						end--do nothing
					end
				if((player.cmd.buttons&BT_SPIN)and(player.powers[pw_super]>0))--Super gets a faster rate of descent
					player.spintic=$+1--spin key tic rate
					if player.mo.momz>-20*FRACUNIT
						player.mo.momz=$-(1250*player.spintic)
						end
					if player.mo.momz<-20*FRACUNIT--descent rate limit (releasing spin key will make gravity affect you and increase your descent rate)
						player.mo.momz=-20*FRACUNIT
						end
					end
				end
			if player.mo.state==S_PLAY_SWIM--rinse and repeat for swimming
				if player.flighthold==1
					player.fly1=20
					player.acceltic=1
					player.flighthold=2
					end
				if((player.flighthold<21)and(player.flighthold>0))
					if player.cmd.buttons&BT_JUMP
						player.acceltic=$+1
						player.mo.momz=$+(2554*player.flighthold)--rate of climb is halved while underwater
						end
					if not(player.cmd.buttons&BT_JUMP)
						player.flighthold=21
						end
					end
				if player.flighthold>20 or player.fly1==0
					if player.cmd.buttons&BT_JUMP
						if player.mo.momz<(6*FRACUNIT)
							player.acceltic=0
							end
						if player.acceltic>0
							player.acceltic=-player.acceltic
							end
						if player.acceltic<0
							player.acceltic=$+1
							player.mo.momz=$-(1250*flighthold)
							end
						if player.acceltic==0
							player.acceltic=0
							end
						end
					if not(player.cmd.buttons&BT_JUMP)
						end
					end
				if((player.cmd.buttons&BT_SPIN)and(player.powers[pw_super]>0))
					player.spintic=$+1
					if player.mo.momz>-15*FRACUNIT--slightly lower rate of descent, but should still be more than enough
						player.mo.momz=$-(1250*player.spintic)
						end
					if player.mo.momz<-15*FRACUNIT
						player.mo.momz=-15*FRACUNIT
						end
					end
				end
			end
		if player.mo.eflags&MFE_VERTICALFLIP--if you're upside down, just do everything the opposite direction
			if player.mo.state==S_PLAY_FLY
				if player.flighthold==1
					player.fly1=20
					player.acceltic=1
					player.flighthold=2
					end
				if((player.flighthold<21)and(player.flighthold>0))
					if player.cmd.buttons&BT_JUMP
						player.acceltic=$+1
						player.mo.momz=$-(6810*player.flighthold)
						end
					if not(player.cmd.buttons&BT_JUMP)
						player.flighthold=21
						end
					end
				if player.flighthold>20 or player.fly1==0
					if player.cmd.buttons&BT_JUMP
						if player.mo.momz>-(6*FRACUNIT)
							player.acceltic=0
							end
						if player.acceltic>0
							player.acceltic=-player.acceltic
							end
						if player.acceltic<0
							player.acceltic=$+1
							player.mo.momz=$+(1250*player.flighthold)
							end
						if player.acceltic==0
							player.acceltic=0
							end
						end
					if not(player.cmd.buttons&BT_JUMP)
						end
					end
				if((player.cmd.buttons&BT_SPIN)and(player.powers[pw_super]>0))
					player.spintic=$+1
					if player.mo.momz<20*FRACUNIT
						player.mo.momz=$+(1250*player.spintic)
						end
					if player.mo.momz>20*FRACUNIT
						player.mo.momz=20*FRACUNIT
						end
					end
				end
			if player.mo.state==S_PLAY_SWIM --tbh i have no idea when anyone would do upside down water, but just in case
				if player.flighthold==1
					player.fly1=20
					player.acceltic=1
					player.flighthold=2
					end
				if((player.flighthold<21)and(player.flighthold>0))
					if player.cmd.buttons&BT_JUMP
						player.acceltic=$+1
						player.mo.momz=$-(2554*player.flighthold)
						end
					if not(player.cmd.buttons&BT_JUMP)
						player.flighthold=21
						end
					end
				if player.flighthold>20 or player.fly1==0
					if player.cmd.buttons&BT_JUMP
						if player.mo.momz>-(6*FRACUNIT)
							player.acceltic=0
							end
						if player.acceltic>0
							player.acceltic=-player.acceltic
							end
						if player.acceltic<0
							player.acceltic=$+1
							player.mo.momz=$+(1250*player.flighthold)
							end
						if player.acceltic==0
							player.acceltic=0
							end
						end
					if not (player.cmd.buttons&BT_JUMP)
						end
					end
				if((player.cmd.buttons&BT_SPIN)and(player.powers[pw_super]))
					player.spintic=$+1
					if player.mo.momz<15*FRACUNIT
						player.mo.momz=$+(1250*player.spintic)
						end
					if player.mo.momz>15*FRACUNIT
						player.mo.momz=15*FRACUNIT
						end
					end
				end
			end
		end

	if(P_IsObjectOnGround(player.mo))
		player.flighthold=0--make sure i don't break anything else on accident
		end
	if player.mo.state==S_PLAY_SWIM or player.powers[pw_super]>0--Super gets inf flight, water time, and flight boosts
		if player.mo.state==S_PLAY_FLY or player.mo.state==S_PLAY_SWIM
			player.powers[pw_tailsfly]=352
			end
		if player.powers[pw_super]>0
			player.powers[pw_underwater]=1050--no suffocating
			player.powers[pw_spacetime]=402
			if player.fly1>0 and player.cmd.buttons&BT_JUMP
				player.flighthold=-(player.fly1-21)--always have the boost
				end
			player.mindash=35*FRACUNIT--increase min/max spindash speed while Super
			player.maxdash=90*FRACUNIT
			player.nosedive=0--Inf slams
			if not(player.mo.eflags&MFE_VERTICALFLIP)
				if(player.mo.momz>8*FRACUNIT or player.mo.momz<-40*FRACUNIT)and player.mo.state==S_PLAY_ROLL
					P_SpawnThokMobj(player)--Get cool visual effects
					if player.mo.momz>25*FRACUNIT--Higher bounce limit when super
						player.mo.momz=25*FRACUNIT
						end
					end
				end
			if player.mo.eflags&MFE_VERTICALFLIP
				if(player.mo.momz<-8*FRACUNIT or player.mo.momz>40*FRACUNIT)and player.mo.state==S_PLAY_ROLL
					P_SpawnThokMobj(player)
					if player.mo.momz<-25*FRACUNIT
						player.mo.momz=-25*FRACUNIT
						end
					end
				end
			end
		end
	if player.powers[pw_super]==0
		player.mindash=15*FRACUNIT--Reset when normal
		player.maxdash=70*FRACUNIT
		end
	if player.mo.state==S_PLAY_RIDE or(player.mo.state==S_PLAY_PAIN and player.rings==0)or player.powers[pw_carry]--reset boost and dive when you jump off a rope or another Tails player, or after you're hurt
		player.flighthold=0
		player.nosedive=0
		end
	
	--Random idea I had near the end of development, if you go fast enough then you can break spikes!
	if player.speed>=50*FRACUNIT and not(player.powers[pw_super]>0)--if above speed and not super
		if player.soundcheck==0
			S_StartSound(player.mo,sfx_cdfm40)--sound cue to make it obvious you can do The Thing(TM)
			end
		player.soundcheck=1
		if player.dashmode<3*TICRATE+1
			player.dashmode=3*TICRATE+1
			end
		player.charflags=$|SF_DASHMODE
		end
	if player.speed<=40*FRACUNIT--had to manually set the lower limit bc audio was kinda buggy otherwise
		player.dashmode=0--reset stuff when yOu'Re ToO sLoW
		if player.soundcheck==1
			S_StartSound(player.mo,sfx_kc65)
			end
		player.soundcheck=0
		end
	if player.powers[pw_super]>0 or (player.mo.state==S_PLAY_ROLL and player.speed>=40*FRACUNIT)--you can only break spikes when super or rolling above the designated speed limit
		player.powers[pw_strong]=$|STR_SPIKE
		else 
		player.powers[pw_strong]=$&~STR_SPIKE
		end
	if player.powers[pw_super]>0--make sure you don't randomly get the dashmode sound while super
		player.dashmode=0
		end
	end
end)



addHook("PlayerThink", function(player)--Change fly/swim speed
if player.mo.skin=="skyfox"
	if player.powers[pw_tailsfly]>0
		if player.mo.state==S_PLAY_FLY
			player.normalspeed=65*FRACUNIT--Flight speed of 36 fracs
			end															--Speed values are multiplied by 0.5555 when flying/swimming
		if player.mo.state==S_PLAY_SWIM 								--Divide the speed you want by that to get the new speed value
			player.normalspeed=50*FRACUNIT--Swim speed of ~28 fracs
			end
		end
	if player.powers[pw_tailsfly]==0
		player.normalspeed=36*FRACUNIT--Reset it
		end
	end
end)



--Test/debugging script. Comment out stuff as needed (it's tabbed over so you can easily add/remove -- or // as needed)
addHook("PlayerThink",function(player)
if player.mo.skin=="skyfox"
--	print("pw_underwater "+player.powers[pw_underwater])
--	print("pw_spacetime	 "+player.powers[pw_spacetime])
--	print("pw_tailsfly	 "+player.powers[pw_tailsfly])
--	print("player.fly1	 "+player.fly1)
--	print("refly		 "+player.refly)
--	print("flightcharge	 "+player.flightcharge)
--	print("flightpower	 "+player.flightpower)
--	print("flightcancel	 "+player.flightcancel)
--	print("flighthold    "+player.flighthold)
--	print("acceltic		 "+player.acceltic)
--	print("spintic		 "+player.spintic)
--	print("cstmtic		 "+player.cstmtic)
--	print("mo.momz		 "+player.mo.momz/FRACUNIT)
--	print("pw_super		 "+player.powers[pw_super])
--	print("hangtic		 "+hangtic)
--	print("mindash		 "+player.mindash/FRACUNIT)
--	print("dashspeed	 "+player.dashspeed/FRACUNIT)
--	print("maxdash		 "+player.maxdash/FRACUNIT)
--	print("normalspeed	 "+player.normalspeed/FRACUNIT)
--	print("player.speed	 "+player.speed/FRACUNIT)
--	print("nosedive		 "+player.nosedive)
--	print("waterrun		 "+player.waterrun)
--	print("ptb			 "+player.ptb)
--	print("dashmode		 "+player.dashmode)
--	print("skinnum		 "+player.skinnum)
--	print("")--These last four are for if you don't want a bunch of copies of each variable printed, and just want to see each one once.
--	print("")--The console shows up to 5 lines at a time, so comment in and out as many blank lines as you need.
--	print("")
--	print("")
	end
end)


---------------------------------------

--Kirb's airwalk remover. I changed it a bit so it would also work if you were standing in place on a platform that collapses underneath you.
//air walk remover, made by Kirb, reusable

addHook("PlayerThink",function(player)//main hook //https://wiki.srb2.org/wiki/Lua/Hooks

if not(player.mo)return end//do not execute the script if the player isn't in game, because it could produce errors (i don't think that there's a wiki page that explains this, after all it isn't that complex)
if not(P_IsObjectOnGround(player.mo))//if the player isn't on ground //https://wiki.srb2.org/wiki/Lua/Functions
and(player.mo.state==S_PLAY_RUN or player.mo.state==S_PLAY_DASH or player.mo.state==S_PLAY_WALK or player.mo.state==S_PLAY_SKID or player.mo.state==S_PLAY_STND or player.mo.state==S_PLAY_WAIT)//and he plays the walk, run, stand or wait animation.. //https://wiki.srb2.org/wiki/List_of_states
and not player.powers[pw_carry]//and not on a rollout ball //https://wiki.srb2.org/wiki/A_CustomPower
	player.mo.state=S_PLAY_FALL//it plays the fall animation //https://wiki.srb2.org/wiki/List_of_states
	end
end)


---------------------------------------

--From XtraSpice_v1. Adds the drown frame to the death animation once you start falling; modified so it works when flipped upside down.
addHook("PlayerThink",function(player)
if player.mo.skin=="skyfox"
	if player.mo.state==S_PLAY_DEAD
		if not(player.mo.eflags&MFE_VERTICALFLIP)
			if player.mo.momz<1
				player.mo.state=S_PLAY_DRWN
				end
			end	
		if player.mo.eflags&MFE_VERTICALFLIP
			if player.mo.momz>-1
				player.mo.state=S_PLAY_DRWN
				end
			end
		end

	--RunOnWater script; modified so you can do it at slower speeds, it won't work in DSZ's slides, and you can cancel the flag.
	if player.speed>20*FRACUNIT
		player.charflags=$1|SF_RUNONWATER
		end
	if player.charflags==SF_RUNONWATER
		player.waterrun=1
		end
	if player.speed<=20*FRACUNIT or((player.mo.state==S_PLAY_PAIN)or(player.mo.state==S_PLAY_STUN)or(player.powers[pw_underwater]>0))or player.cmd.buttons&BT_CUSTOM1
		player.charflags=$&~SF_RUNONWATER
		player.waterrun=0
		end

	--Aircurl code; modified so you can also recurl after being hurt for recovery, and it won't break DSZ's slides or ACZ's minecarts.
	if player.cmd.buttons&BT_USE
	and player.charability2==CA2_SPINDASH
		if not(P_IsObjectOnGround(player.mo))
		and not player.powers[pw_carry]
		and(player.mo.state==S_PLAY_FALL or player.mo.state==S_PLAY_SPRING or player.mo.state==S_PLAY_PAIN or player.mo.state==S_PLAY_WALK)
			player.pflags=$&~PF_NOJUMPDAMAGE 
			player.pflags=$|PF_JUMPED
			player.pflags=$&~PF_THOKKED
			player.mo.state=S_PLAY_ROLL
			S_StartSound(player.mo,sfx_zoom)
			P_SpawnThokMobj(player)
		else
			return
			end
		end
	end
end)


---------------------------------------

--All Characters super! script from Mystic Akito. Modified to increase the necessary rings for SF, and make the script specific to him.
local function superAll(player)
if player.mo and player.mo.valid
	if player.mo.skin=="skyfox"
		if player.rings<75 and player.powers[pw_super]==0
			player.charflags=$&~SF_SUPER
		elseif player.rings>=75
			player.charflags=$|SF_SUPER
			end
		end
    end
end
addHook("PlayerThink",superAll)


---------------------------------------

--Copied code and sound effect from Krabs' L_Uncurl-v4. Good thing it's Open Assets, huh?
local UNCURL_LOCKTIME=8
freeslot("sfx_uncurl")

COM_AddCommand("uncurltoggle",function(player,value)
	if not(player and player.valid and player.mo)
		CONS_Printf(player,"This command can only be used inside a level.")
		return
		end
	if not(player.mo.skin=="skyfox")
		CONS_Printf(player,"You must be playing as SkyFox to use this command.")
		return
		end
	if value=="0"or value=="no"or value=="off"or value=="false"
		player.uncurltoggle=0
		CONS_Printf(player,"Uncurl toggle disabled.")
	elseif value=="1"or value=="yes"or value=="on"or value=="true"
		player.uncurltoggle=1
		CONS_Printf(player,"Uncurl toggle enabled.")
	else
		if player.uncurltoggle==1
			CONS_Printf(player,"uncurltoggle is on. Default is on.")
		else
			CONS_Printf(player,"uncurltoggle is off. Default is on.")
		end
	end
end,0)

addHook("ThinkFrame",function(player)
	for player in players.iterate()
		//Init
		if player.mo.skin=="skyfox"
			if player.init==nil
				player.init=true
				player.prevbuttons=player.cmd.buttons
				if player.uncurltoggle==nil
					player.uncurltoggle=1
					end
				return
			end
		
			if player.mo and player.playerstate==PST_LIVE and not player.exiting and not player.powers[pw_nocontrol] and not P_PlayerInPain(player)
				local pbtn=player.prevbuttons
				local btn=player.cmd.buttons
				local mo=player.mo
			
				//Uncurl
				if mo.state==S_PLAY_ROLL and P_IsObjectOnGround(mo)
					local uncurlinput=false
					local recurlinput=false
					if player.uncurltoggle==1
						uncurlinput=(btn&BT_USE)and not(pbtn&BT_USE)
					else
						uncurlinput=(pbtn&BT_USE)and not(btn&BT_USE)
						recurlinput=(btn&BT_USE)and not(pbtn&BT_USE)
					end
				
					if mo.uncurl_lock==UNCURL_LOCKTIME and uncurlinput
						uncurlinput=false
					end
				
					if uncurlinput
						mo.will_uncurl=true
					end
					if recurlinput
						mo.will_uncurl=false
					end
				
					if mo.uncurl_lock
						mo.uncurl_lock=max(0,$-1)
					
					elseif mo.will_uncurl
						mo.uncurl_lock=UNCURL_LOCKTIME
						mo.uncurlready=false
						if FixedHypot(mo.momx, mo.momy)>=player.runspeed
							mo.state=S_PLAY_RUN
						else
							mo.state=S_PLAY_WALK
						end
						if player.pflags&PF_SPINNING
							player.pflags=$1&~PF_SPINNING
						end
						S_StartSound(mo,sfx_uncurl)
						S_StopSoundByID(mo,sfx_spin)
					end
				else
					mo.uncurl_lock=UNCURL_LOCKTIME
					mo.will_uncurl=false
				end
				player.prevbuttons=btn
			end
		end
	end
end)


---------------------------------------

--Unabashedly stolen from clairebun's 'The Momentum Mod,' or VL_Momentum-v9.wad.
--Modified so it doesn't change spindash or ability physics, just has the speed carrying over, and so that it only applies to SF (like all other stolen scripts).
local debug=0
addHook('ThinkFrame',do
	for player in players.iterate do
		if player.mo.skin=="skyfox"
			if player.mo and player.mo.scale and player.mo.friction and player.mo.movefactor
				local pmo=player.mo
				//Create history
				if player.waterlast==nil
					player.waterlast=false
					player.dashlast=false
					player.realfriction=pmo.friction
				end
				local skin=skins[pmo.skin]

				local water=1+(pmo.eflags&MFE_UNDERWATER)/MFE_UNDERWATER//Water factor for momentum halving
				local grounded=P_IsObjectOnGround(pmo)
				local nmom=skin.normalspeed//Skin normalspeed, the integral component
				//Dashmode overrides skin normalspeed
				if player.dashmode>=3*TICRATE
					nmom=player.normalspeed
				end

				local scale=pmo.scale//Normalspeed calculations are affected by scale
				local friction=FixedDiv(pmo.friction,pmo.movefactor)//Reversing friction is required for sustaining ground momentum
				local pmom=FixedDiv(FixedHypot(player.rmomx,player.rmomy),scale)//Current speed, scaled for normalspeed calculations
				local pwup=(player.powers[pw_sneakers])or(player.powers[pw_super])//Speed-ups multiply max allowed speed by 5/3
				local momangle=R_PointToAngle2(0,0,player.rmomx,player.rmomy)//Used for angling new momentum in ability cases
				//Adjust current speed reading for calculations with pwup status
				if pwup
					pmom=$*3/5
				end
				local mom=FixedHypot(pmo.momx,pmo.momy)

				//General momentum scaling

				//Do ground momentum
				if grounded
					//The amount of momentum to sustain
					local sustain=FixedDiv(min(pmom*water,nmom*2),friction)
-- 					if pmom>player.normalspeed
					player.normalspeed=max(nmom,sustain)
-- 					end
				end

				//Update history
				player.waterlast=(pmo.eflags&MFE_UNDERWATER>0)
				player.dashlast=(player.pflags&PF_STARTDASH>0)

				//DEBUG//
				if debug
					print("momz "+pmo.momz/FRACUNIT)
					print("actionspd   "+player.actionspd/FRACUNIT)
					print("pmom        "+pmom/FRACUNIT)
					print("normalspeed "+player.normalspeed/FRACUNIT)
				end
			end
		end
	end
end)


---------------------------------------

--EeveeEuphoria's Cancelable Super Form, v2.1, modified so you can still do it while falling and can refly afterwards.
--[[ Cancel Super Form rewrite
Made this just in case someone doesn't like MMT for some reason, but wants this. It's just code taken from MMT.
]]
addHook("MobjThinker",function(mobj) local player=mobj.player

local function SoupTime()
	if(player.powers[pw_flashing] < TICRATE)
	and player.mo.skin=="skyfox"
	and not player.waittogetdown
	and(not(player.pflags&PF_THOKKED)or player.PreviousFrameThok)
	and not(player.pflags&PF_SHIELDABILITY)
	and not(player.pflags&PF_FINISHED)
	and not(player.pflags&PF_SPINNING)
	and(everysuper!="disable")
	and(player.pflags&PF_JUMPED)
	and not((player.mo.state==S_PLAY_SUPER_TRANS1)or(player.mo.state==S_PLAY_SUPER_TRANS2)or(player.mo.state==S_PLAY_SUPER_TRANS3)or(player.mo.state==S_PLAY_SUPER_TRANS4)or(player.mo.state==S_PLAY_SUPER_TRANS5)or(player.mo.state==S_PLAY_SUPER_TRANS6))
	and not player.HasGlided
	and(player.playerstate==PST_LIVE)
	and not P_IsObjectOnGround(player.mo)
	and not mmtVersion
		return true
	else
		return false
	end
end

	if SoupTime()and player.powers[pw_super] and(player.spintic==0)and player.cmd.buttons&BT_CUSTOM2
		player.pflags =$&~PF_NOJUMPDAMAGE
		player.pflags =$|PF_JUMPED
		player.pflags =$&~PF_THOKKED
		P_SpawnShieldOrb(player)
		player.powers[pw_flashing]=TICRATE
		player.powers[pw_super]=0
		player.mo.color=player.skincolor
		P_RestoreMusic(player)
	end
end,MT_PLAYER)


---------------------------------------

--SlainLBS's Character Specific Jingles, v2.2. Used for the Super music.
--Leaving most of it in because I might find some music I wanna put in later, idk
addHook("MusicChange",function(oldname,newname)
	if consoleplayer
		local character=skins[consoleplayer.skin].name
		if character=="skyfox"//skin to use custom themes
--[[		if newname=="_clear" //intercept and override jingles
			return"SONIC1"--level clear
			elseif newname=="_inv"
			return"SONI1I"--invincibility
			elseif newname=="SPEC1"or newname=="SPEC2"or newname=="SPEC3"or newname=="SPEC4"or newname=="SPEC5"or newname=="SPEC6"or newname=="SPEC7"or newname=="bhz"
			return"SONI1C"--special stages
			elseif newname=="_shoes"
			return"SONI1H"--speed shoes
			else]]if newname=="_super"
--			return"DRRRTLR"--wanted to use the Ring Racers remix of Tails' Lab for super theme but decided against it. I'll leave it in if anyone wants to mess with it
			return"FRONACC"--super
--[[		elseif newname=="_1up"--why doesn't it fade right
			return"SKYPTRL"--life monitor
			elseif newname=="_gover"
			return"SONI1G"--game over
]]			end
		end
	end
end)